unit options1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, CheckLst, Buttons, uPSComponent;

type

  { TAOptions }

  TAOptions = class(TForm)
    OPS: TPSScript;
    ScriptInc_Dialog: TOpenDialog;
    ScriptInc_Add: TButton;
    ScriptInc_Delete: TButton;
    ScriptInc_List: TCheckListBox;
    GroupBox2: TGroupBox;
    procedure ScriptInc_AddClick(Sender: TObject);
    procedure ScriptInc_DeleteClick(Sender: TObject);
    procedure ScriptInc_ListItemClick(Sender: TObject; Index: integer);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  AOptions: TAOptions;

implementation

{ TAOptions }

uses RNDCE1;

procedure TAOptions.ScriptInc_AddClick(Sender: TObject);
var
  S: String;
  I: Integer;
begin
  if ScriptInc_Dialog.Execute and FileExists(ScriptInc_Dialog.FileName) then
  begin
    OPS.Script.Clear;
    OPS.Script.LoadFromFile(ScriptInc_Dialog.FileName);
    if OPS.Compile then
    begin
      ScriptInc_List.Items.Add(ExtractFileName(ScriptInc_Dialog.FileName));
      Includes.Add(ScriptInc_Dialog.FileName);
    end
// compile script, if success then check box, else do not check box
    else
    begin
      S:='';
      for I:=0 to OPS.CompilerMessageCount - 1 do
       S:=S + #13#10 + OPS.CompilerMessages[I].MessageToString;
      ShowMessage(S);
      ScriptInc_List.Items.Add(ExtractFileName(ScriptInc_Dialog.FileName));
      ScriptInc_List.Checked[ScriptInc_List.Items.Count-1]:=False;
      Includes.Append('//' + ScriptInc_Dialog.FileName);
    end;
  end;
end;

procedure TAOptions.ScriptInc_DeleteClick(Sender: TObject);
begin
  if ScriptInc_List.ItemIndex >= 0 then
   if Includes.Count > ScriptInc_List.ItemIndex then
   begin
     Includes.Delete(ScriptInc_List.ItemIndex);
     ScriptInc_List.Items.Delete(ScriptInc_List.ItemIndex);
   end;
end;

procedure TAOptions.ScriptInc_ListItemClick(Sender: TObject; Index: integer);
begin

end;

initialization
  {$I options1.lrs}

end.

