program RNDCE;

{$mode objfpc}{$H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Interfaces, // this includes the LCL widgetset
  Forms
  { add your units here }, RNDCE1, PascalScript, chunk_confs, conf_chr_h, conf_gfx_h, Files, files_c, main_h,
  misc_fromsource, rndtypes, Dcu1, script1, options1, init_c, SysUtils;

var
  S, D: String;
  I: Integer;
  dosave: Boolean;

begin
  Application.Initialize;
  Application.CreateForm(TAMain, AMain);
  Application.CreateForm(TAOptions, AOptions);
  CommandLineMode:=(Paramcount = 3);
  case Paramcount of
    0: Application.Run;
    1:
    begin
// load level <level>
// load script <script>
      S:=ParamStr(1);
      if FileExists(S) then// level or script file???
       if (Copy(S, Length(S)-5, Length(S)) = '.level') then
       begin
         AMain.LevelFile.FileName:=S;
         AMain.LevelFileAcceptFileName(AMain, S);
       end
       else
       begin
         AMain.ScriptFile.FileName:=S;
         AMain.ScriptMemo.Lines.LoadFromFile(S);
       end;
      Application.Run;
    end;
    2:
    if FileExists(ParamStr(1)) and FileExists(ParamStr(2)) then
    begin// load level and script  <level> <script>
      S:=ParamStr(1);
      AMain.LevelFile.FileName:=S;
// done in formcreate      setLevelInfoToDefaults(@lvl, elements1);
      AMain.ScriptMemo.Lines.LoadFromFile(ParamStr(2));
      if LoadLevelFromFileInfo_RND(@lvl, elements1, S) then
       Application.Run
      else Debug('Could not load level "'+ S +'"');
    end
    else
    begin
      if not FileExists(ParamStr(1)) then Debug('Could not find level "'+ParamStr(1)+'"');
      if not FileExists(ParamStr(2)) then Debug('Could not find script "'+ParamStr(2)+'"');
      Application.Run;
    end;
    3:
    begin
// run script on level          -run <level> <script>
// run script on levelset       -run <levelset directory> <script>
      if (ParamStr(1) <> '-run') and (ParamStr(1) <> '-rund') then
      begin
        Debug('With 3 parameters, the first parameter must be -run or -rund');
        Exit;
      end;
      dosave:=(ParamStr(1) = '-run');
      S:=ParamStr(2);
      if FileExists(ParamStr(3)) then
      begin
        Debug('Script file: ' + ParamStr(3));
        AMain.ScriptMemo.Lines.LoadFromFile(ParamStr(3));
      end
      else
      begin
        Debug('Script file "' + ParamStr(3) + '" was not found');
        Exit;
      end;
      if DirectoryExists(S) then
      begin
        if Copy(S, Length(S), 1) = DirectorySeparator then
         Delete(S, Length(S), 1);
        D:=S;
        for I:=0 to 999 do
        if FileExists(D + DirectorySeparator + IntToStrLen(I, 3) + '.level') then
        begin
          S:=D + DirectorySeparator + IntToStrLen(I, 3) + '.level';
          Debug('Level file: ' + S, OUTPUT_NOPROCESSING);
          AMain.LevelFile.FileName:=S;
          modifiedlevel:=false;
          AMain.LevelFileAcceptFileName(AMain, S);
          Debug('Running script...', OUTPUT_NOPROCESSING);
          AMain.Script_RunClick(AMain);
          if dosave then
          begin
            Debug('Saving level...', OUTPUT_NOPROCESSING);
            AMain.Level_SaveClick(AMain);
          end;
        end;
      end
      else if FileExists(S) then
      begin
        Debug('Level file: ' + S);
        AMain.LevelFile.FileName:=S;
        setLevelInfoToDefaults(@lvl, elements1);// done in formcreate, but do it again
        if LoadLevelFromFileInfo_RND(@lvl, elements1, S) then
        begin
          Debug('Running script...');
          AMain.Script_RunClick(AMain);
          if dosave then
          begin
            Debug('Saving level...');
            AMain.Level_SaveClick(AMain);
          end;
        end
        else Debug('Could not load level file');
      end
      else Debug(S + ' is not a file or directory');
    end;
  end;
  AMain.LogMemo.Lines.SaveToFile('rndscrlog.txt');
end.

